VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form frmMain 
   Caption         =   "CANtool Automation Tester"
   ClientHeight    =   2775
   ClientLeft      =   4245
   ClientTop       =   11100
   ClientWidth     =   9735
   LinkTopic       =   "Form1"
   ScaleHeight     =   2775
   ScaleWidth      =   9735
   Begin VB.Frame Frame2 
      Caption         =   "ErrorHandling"
      Height          =   855
      Left            =   120
      TabIndex        =   11
      Top             =   1800
      Width           =   4695
      Begin VB.CommandButton ErrorSignal 
         Caption         =   "ErrorSignal"
         Height          =   360
         Left            =   1560
         TabIndex        =   13
         Top             =   360
         Width           =   1290
      End
      Begin VB.CommandButton ErrorButton 
         Caption         =   "ErrorReserved"
         Height          =   360
         Left            =   120
         TabIndex        =   12
         Top             =   360
         Width           =   1290
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   "Signal"
      Height          =   735
      Left            =   120
      TabIndex        =   5
      Top             =   960
      Width           =   4695
      Begin VB.Timer SignalTimer 
         Enabled         =   0   'False
         Interval        =   500
         Left            =   3960
         Top             =   240
      End
      Begin VB.Label SignalValue 
         Height          =   255
         Left            =   1560
         TabIndex        =   7
         Top             =   360
         Width           =   1575
      End
      Begin VB.Label Label4 
         Caption         =   "Non Signal"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   360
         Width           =   1335
      End
   End
   Begin ComctlLib.Slider PedalSlider 
      Height          =   255
      Left            =   5160
      TabIndex        =   2
      Top             =   840
      Width           =   4095
      _ExtentX        =   7223
      _ExtentY        =   450
      _Version        =   327682
      Max             =   100
      TickFrequency   =   10
   End
   Begin VB.CommandButton ConnectButton 
      Caption         =   "Connect"
      Height          =   360
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1290
   End
   Begin VB.Frame Frame1 
      Caption         =   "CANoe"
      Height          =   735
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   4695
      Begin VB.CommandButton Command1 
         Caption         =   "Select Signal"
         Height          =   375
         Left            =   3000
         TabIndex        =   14
         Top             =   240
         Width           =   1290
      End
      Begin VB.CommandButton Start 
         Caption         =   "Start"
         Height          =   375
         Left            =   1560
         TabIndex        =   10
         Top             =   240
         Width           =   1290
      End
   End
   Begin VB.Frame Environment 
      Caption         =   "Environment"
      Height          =   2415
      Left            =   4920
      TabIndex        =   3
      Top             =   240
      Width           =   4695
      Begin ComctlLib.Slider PedalSlider2 
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   1440
         Width           =   4095
         _ExtentX        =   7223
         _ExtentY        =   450
         _Version        =   327682
         Max             =   100
         TickFrequency   =   10
      End
      Begin VB.Label Label5 
         Caption         =   "Pedal position (OnChange)"
         Height          =   255
         Left            =   360
         TabIndex        =   9
         Top             =   1080
         Width           =   3855
      End
      Begin VB.Label Label3 
         Caption         =   "Pedal position (evPedalPosition)"
         Height          =   255
         Left            =   360
         TabIndex        =   4
         Top             =   360
         Width           =   2895
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim WithEvents app         As CANoe.Application
Attribute app.VB_VarHelpID = -1
Dim WithEvents exp         As CANdbExplorer.SymbolSelection
Attribute exp.VB_VarHelpID = -1
Dim WithEvents Measurement As CANoe.Measurement
Attribute Measurement.VB_VarHelpID = -1
Dim WithEvents Pedal       As CANoe.EnvironmentVariable
Attribute Pedal.VB_VarHelpID = -1
Dim SignalVal
Dim CarSpeed
Dim Connected
Dim HelpPath
Dim bus, msg, sig As String
Dim Country As Integer
Dim Tool
Dim MemDisclaim

Const CountryFilePath = "..\..\..\..\exec32\vector.ini"
Const StrictFilePath = "..\..\..\..\vcustom.ini"
Dim CountryStream, StrictStream, FSO

Private Sub app_OnQuit()
  MsgBox "Disconnecting due to CANoe shutdown... Program will be closed ! "
  Unload Me
End Sub

Private Sub Command1_Click()
  Dim db
  exp.Databases.RemoveAll
  For Each db In app.configuration.GeneralSetup.DatabaseSetup.Databases
    exp.Databases.Add db.FullName
  Next
    
  exp.DialogType = symSignalSelection
  Call SelectLanguage
  
  If Country = 1 Then
  exp.HelpFile = HelpPath & "\CANoe01.hlp"
  ElseIf Country = 49 Then
  exp.HelpFile = HelpPath & "\CANoe49.hlp"
  End If
  
  exp.Open
End Sub

Private Sub ConnectButton_Click()
  On Error GoTo Fail
  If Connected = False Then
      Set app = New CANoe.Application
      Call OpenConfig("Automot\Automot.cfg")
      app.CAPL.Compile
      Connected = True
      Start.Enabled = True
      Command1.Enabled = True
      PedalSlider.Enabled = True
      ErrorButton.Enabled = True
      ErrorSignal.Enabled = True
      ConnectButton.Caption = "Disconnect"
      Set Measurement = app.Measurement
      If Measurement.Running Then
         Start.Caption = "Stop"
      Else
         Start.Caption = "Start"
      End If
      Set Pedal = app.Environment.GetVariable("EnvPedalPosition")
  Else
    Command1.Enabled = False
    ErrorSignal.Enabled = False
    ErrorButton.Enabled = False
    Start.Enabled = False
    PedalSlider.Enabled = False
    SignalTimer.Enabled = False
    Set SignalVal = Nothing
    Set CarSpeed = Nothing
    Set Pedal = Nothing
    Set Measurement = Nothing
    Set app = Nothing
    Connected = False
    ConnectButton.Caption = "Connect"
  End If
  Exit Sub
Fail:
  Call ShowError
End Sub

Private Sub ErrorButton_Click()
  Dim reserved
  On Error GoTo Fail
  Set reserved = app.Reserved1
  Exit Sub
Fail:
  Call ShowError
End Sub

Private Sub ErrorSignal_Click()
  Dim signal
  On Error GoTo Fail
  Set signal = app.bus.GetSignal(1, "TestMessage", "TestSignal")
  Exit Sub
Fail:
  Call ShowError
End Sub

Private Sub Form_Load()
  
  Set Tool = CreateObject("CANutil.ToolInfo")
  Set FSO = CreateObject("Scripting.FileSystemObject")
  Set CountryStream = FSO.OpenTextFile(CountryFilePath, 1)
  Set StrictStream = FSO.OpenTextFile(StrictFilePath, 1)
  
    If MemDisclaim = 0 Then
      If Tool.ShowDisclaimer(ReadCountry, ReadStrict, 0, 0) <> 1 Then
        MemDisclaim = 0
        Unload Me
        End
      End If
    End If
           
   MemDisclaim = 1
      
   Set app = New CANoe.Application
   Set exp = New CANdbExplorer.SymbolSelection
  
   Connected = False
   Command1.Enabled = False
   Start.Enabled = False
   PedalSlider.Enabled = False
   ErrorButton.Enabled = False
   ErrorSignal.Enabled = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Set exp = Nothing
  Set app = Nothing
End Sub

Private Sub Measurement_OnExit()
  Start.Caption = "Start"
  SignalTimer.Enabled = False
End Sub


Private Sub Measurement_OnStart()
  Start.Caption = "Stop"
  ConnectButton.Enabled = False
End Sub

Private Sub Measurement_OnStop()
  Start.Caption = "Start"
  ConnectButton.Enabled = True
End Sub

Private Sub Pedal_OnChange(ByVal Value As Variant)
  PedalSlider = Value
  PedalSlider2 = Value
End Sub

Private Sub PedalSlider_Scroll()
  Pedal.Value = PedalSlider
End Sub

Private Sub SignalTimer_Timer()
  On Error GoTo Fail
  SignalValue = SignalVal
  'CarSpeedValue = CarSpeed
Fail:
End Sub

Private Sub Start_Click()
  If Start.Caption = "Start" Then
    Measurement.Start
  Else
    Measurement.Stop
  End If
End Sub


Function GetDemoPath(relpath)
  Dim FSO, folder, file, names, i
  On Error Resume Next
  Set FSO = CreateObject("Scripting.FileSystemObject")
  
  Set folder = FSO.GetFolder(app.Path).ParentFolder
  Set file = FSO.GetFile(folder.Path & "\Demo_CAN_cn\" & relpath)
  
  HelpPath = app.Path
  GetDemoPath = file.Path
  
End Function

Sub OpenConfig(relpath)
  Dim full, counter
  full = GetDemoPath(relpath)
  If full <> app.configuration.FullName Then
    If MsgBox("Automot\Automot.cfg not found, do you want to search for it?", vbYesNo + vbQuestion + vbMsgBoxSetForeground, "Attention") = vbYes Then
      app.Open (full)
    Else
      End
    End If
  End If
End Sub

Sub ShowError()
  Dim msg
  msg = "The object returned the following error: " & Chr(13) & Chr(13) & _
        "Code: 0x" & Hex(Err.Number) & Chr(13) & _
        "Source: " & Err.Source & Chr(13) & _
        "Description: " & Err.Description
  MsgBox msg, vbSystemModal + vbMsgBoxHelpButton, "Error", Err.HelpFile, Err.HelpContext
End Sub
  
Private Sub exp_OnApply(ByVal items As CANdbExplorer.ISymbolSelectionItems)
   Dim FName As String
   Dim pos, pos1, pos2 As Long
   Dim counter, CanChannel As Integer
   Dim itm

   pos = 0
   counter = 0

   For Each itm In items
      FName = itm.FullName
      'split fullname into db, msg and signal part
      Do
         pos = InStr(pos + 1, FName, "::")
         counter = counter + 1
         If counter = 1 Then
            bus = Left(FName, pos - 1)
            pos1 = pos
         End If
         If counter = 2 Then
            msg = Mid(FName, pos1 + 2, pos - pos1 - 2)
            pos2 = pos
         End If
         If counter = 3 Then
            sig = Right(FName, Len(FName) - pos2 - 1)
         End If
      Loop Until pos = 0
   Next
  
   'select CAN-Channel
   If bus = "ibus" Then
      CanChannel = 1
   ElseIf bus = "motbus" Then
      CanChannel = 2
   End If
   
   On Error GoTo Fail
   Set SignalVal = app.bus.GetSignal(CanChannel, msg, sig)
   Label4.Caption = sig
   SignalTimer.Enabled = True
   Exit Sub
   
Fail:
   Call ShowError
End Sub

Function SelectLanguage()

  Dim Filenum As Integer, Line As String

  Filenum = FreeFile
  
  Open HelpPath & "\vector.ini" For Input As #Filenum

  While Not EOF(Filenum)
    Line Input #Filenum, Line
    If Line = "Country=49" Then
      Country = 49
    ElseIf Line = "Country=01" Then
      Country = 1
    End If
  Wend

  SelectLanguage = Country
End Function

Function ReadCountry()
' This function will read the country code of application
  Dim str
  
    Do While Not CountryStream.AtEndOfStream
      str = CountryStream.ReadLine
      If str = "Country=49" Then
        ReadCountry = 49
      ElseIf str = "Country=01" Then
        ReadCountry = 1
      End If
    Loop
    
    CountryStream.Close
End Function

Function ReadStrict()
' This function will read the distribution of application
  Dim str
  
  Do While Not StrictStream.AtEndOfStream
    str = StrictStream.ReadLine
    If str = "Distribution=NoUS" Then
      ReadStrict = 0
    ElseIf str = "Distribution=US" Then
      ReadStrict = 1
    End If
  Loop

  StrictStream.Close
End Function
